/* compile by : $ valac imgizor.vala --pkg gtk+-3.0 --pkg gmodule-2.0 --pkg glib-2.0 --pkg posix
Dr. Amr Osman <dr3mro@gmail.com>
image resize and rotate 0.5
plz if you have a patch just email it to me and it will be incorporated to main trunk
*/

using Gtk;
using GLib;
using Posix;

void converter(string strex,Dialog dialog1,Label label10){
	try {
	string std_out , std_err;
	int extus;
	Process.spawn_command_line_sync (strex,out std_out ,out std_err,out extus);
	
	if (std_err == ""){
			print("%s",std_err);
			Gtk.main_quit();
			}
	else {
			dialog1.show_all();
			label10.set_text(std_err);
					};

    } catch (Error e){
		print("%s",e.message); }
    
    }
    
int main (string[] args) {     
    
    Gtk.init (ref args);
    if (args.length < 2){
        print ("please pass an image name as an argument\n");
        exit(1);
    };

    string input ="\"" + args[1] + "\"";
    
    var output = input;
    var convert=true;
    string filename="";
    string extension;
    string[] splittedinput = input.split(".");
    if (splittedinput.length > 1 ) {
	    int extendex = splittedinput.length -1 ;
	    string[] listname = splittedinput[0:extendex];
    	extension = splittedinput[extendex];
    		foreach (string part in listname){
    		    if ( filename == ""){
    				    filename = filename +  part ;
    						    }
    		    else{
    				    filename = filename + "." + part ;
    						    };
    					            };
    					            	}
    else {
    	filename = input;
    	extension = "image";
	    };
	print (@"filename:\t$filename\nextension:\t$extension\n");
    
    try {
        var builder = new Builder ();
        builder.add_from_file ("/usr/share/imgizor/imgizor.ui");
        builder.connect_signals (null);
        var window = builder.get_object ("window") as Window;
        var label10 = builder.get_object("label10") as Label;
        var dialog1 =builder.get_object("dialog1") as Dialog;        
        var aboutdialog = builder.get_object ("aboutdialog") as AboutDialog;
        var combobox1 = builder.get_object("combobox1") as ComboBox;
        var combobox2 = builder.get_object("combobox2") as ComboBox;
        var liststore1 = builder.get_object("liststore1") as ListStore;
        var liststore2 = builder.get_object("liststore2") as ListStore;
        var button1 = builder.get_object("button1") as Button;
        var button3 = builder.get_object("button3") as Button;
        var radiobutton0 = builder.get_object("radiobutton0") as RadioButton;
        var radiobutton1 = builder.get_object("radiobutton1") as RadioButton;
        var radiobutton2 = builder.get_object("radiobutton2") as RadioButton;
        var radiobutton3 = builder.get_object("radiobutton3") as RadioButton;
        var radiobutton4 = builder.get_object("radiobutton4") as RadioButton;
        var radiobutton5 = builder.get_object("radiobutton5") as RadioButton;        
        var radiobutton6 = builder.get_object("radiobutton6") as RadioButton;                
        var radiobutton7 = builder.get_object("radiobutton7") as RadioButton;
        var radiobutton8 = builder.get_object("radiobutton8") as RadioButton;
        var adjust1 = builder.get_object("adjustment1") as Adjustment;
        var adjust2 = builder.get_object("adjustment2") as Adjustment;
        var adjust3 = builder.get_object("adjustment3") as Adjustment;
        var adjust4 = builder.get_object("adjustment4") as Adjustment;
        var entrybuffer1 = builder.get_object("entrybuffer1") as EntryBuffer;
        var spinbutton1 = builder.get_object("spinbutton1")  as SpinButton;      
        var spinbutton2 = builder.get_object("spinbutton2")  as SpinButton;   
        var spinbutton3 = builder.get_object("spinbutton3")  as SpinButton;   
        var spinbutton4 = builder.get_object("spinbutton4")  as SpinButton;  
        var entry1 = builder.get_object("entry1") as Entry;

        TreeIter iter;
        
        string[] resolutions ={
                        "96x96",
                        "128x128",
                        "640x480",
                        "800x600",
                        "1024x768",
                        "1280x960"};
        
        for (int i =0 ;i <= 5 ;i++){
        
            liststore1.append(out iter);
            liststore1.set(iter,0,resolutions[i],-1,i);
        };



        var cell = new CellRendererText();
        combobox1.pack_start( cell, false  );
        combobox1.set_attributes( cell, "text", 0 );
        combobox1.set_active(0);
        combobox1.set_sensitive(false);
        
        string[] execute ={"convert",input};
        string[] degrees ={
                           "+90",
                           "-90",
                           "+180"};

        for (int i =0 ;i <= 2 ;i++){
        
            liststore2.append(out iter);
            liststore2.set(iter,0,degrees[i],-1,i);
        };

        combobox2.pack_start( cell, false  );
        combobox2.set_attributes( cell, "text", 0 );
        combobox2.set_active(0);
        combobox2.set_sensitive(false);

        int resize = 0;
        int rotate = 0;
        string save = "place";

        radiobutton0.toggled.connect (() => {
                   resize =0;
                   combobox1.set_sensitive(false);
                   spinbutton1.set_sensitive(false);
                   spinbutton2.set_sensitive(false);
                   spinbutton3.set_sensitive(false);
                   if (rotate == 0){
                        button3.set_sensitive(false);
                   };


            });
        
        radiobutton1.toggled.connect (() => {
                   resize = 1 ;
                   combobox1.set_sensitive(true);
                   spinbutton1.set_sensitive(false);
                   spinbutton2.set_sensitive(false);
                   spinbutton3.set_sensitive(false);
                   button3.set_sensitive(true);
            });
        
        radiobutton2.toggled.connect (() => {
                   resize = 2 ;
                   combobox1.set_sensitive(false);
                   spinbutton1.set_sensitive(true);
                   spinbutton2.set_sensitive(false);
                   spinbutton3.set_sensitive(false);
                   button3.set_sensitive(true);
            });
        
        radiobutton3.toggled.connect (() => {
                   resize = 3 ;
                   combobox1.set_sensitive(false);
                   spinbutton1.set_sensitive(false);
                   spinbutton2.set_sensitive(true);
                   spinbutton3.set_sensitive(true);
                   button3.set_sensitive(true);

            });                     

        radiobutton8.toggled.connect (() => {
                   rotate = 0 ;
                   if (resize == 0){
                   button3.set_sensitive(false);
                   combobox2.set_sensitive(false);
                   spinbutton4.set_sensitive(false);
                   
                };
            });  



        radiobutton4.toggled.connect (() => {
                   rotate = 1 ;
                   button3.set_sensitive(true);
                   combobox2.set_sensitive(true);
                   spinbutton4.set_sensitive(false);


            });  

        radiobutton5.toggled.connect (() => {
                   rotate = 2 ;
                   button3.set_sensitive(true);
                   combobox2.set_sensitive(false);
                   spinbutton4.set_sensitive(true);                   
            });  

        radiobutton6.toggled.connect (() => {
                   save = "place" ;
                   entry1.set_sensitive(false);
            });  

        radiobutton7.toggled.connect (() => {
                   save = "append" ;
                   entry1.set_sensitive(true);                   
            });  

        button1.clicked.connect(() => {
                aboutdialog.show_all();

            
            });
        button3.clicked.connect(() => {

                               if (resize == 1 ) {
                                var selected = combobox1.get_active() ;
                                var resolution = resolutions[selected];
                                execute += "-resize";
                                execute += resolution;
                                                    };


                               if (resize == 2) {
                                var adval1 = (int)adjust1.get_value();
                                execute += "-resize";
                                execute += adval1.to_string()+"%";
                               };


                               if (resize == 3) {
                                var adval2 = (int) adjust2.get_value();
                                var adval3 = (int) adjust3.get_value();
                                execute += "-resize";
                                execute += adval2.to_string()+"x"+adval3.to_string();
                                };
                                

                               if (rotate == 1) {
                                var selected = combobox2.get_active() ;
                                var degree = degrees[selected];
                                execute += "-rotate";
                                execute += degree;
                                                   };

                               if (rotate == 2) {
                                var adval4 = (int) adjust4.get_value();
                                execute += "-rotate";
                                execute += adval4.to_string();
                               };

                               if (save == "place") {
                                output = input;
                                execute += output;
                               };
                              
                               if (save == "append") {
                                var append = entrybuffer1.get_text();
                                output = filename + append +"." + extension;
                                execute += output;
                               };
                              var strex  = "";

                              
                              if (execute.length < 4 ){
                                    convert=false;}
                              else {
                                    convert=true;
                              };

                              
                              foreach (string exec in execute) {
                                        strex = strex +" "+ exec;
                                            } ;
                              execute={"convert"};
                              
                            if(convert == true ){
                            //print("%s",strex);
                            converter(strex,dialog1,label10);
                            };
							//window.hide();
                           
                            });
        
        
        

        window.show_all ();
        Gtk.main ();

    } catch (Error e) {
        print ("Could not load UI: %s\n", e.message);
        return 1;
    
   } 



    return 0;
}

